Recommendations - List

Obtains cached recommendations for a subscription. The recommendations are generated or computed by invoking generateRecommendations.

GET https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Advisor/recommendations?api-version=2026-10-01
GET https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Advisor/recommendations?api-version=2026-10-01&$filter={$filter}&$top={$top}&$skipToken={$skipToken}

URI Parameters

Name In Required Type Description
subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

api-version
query True

string

minLength: 1

The API version to use for this operation.

$filter
query

string

The filter to apply to the recommendations.
Filter can be applied to properties ['ResourceId', 'ResourceGroup', 'RecommendationTypeGuid', 'Category', 'SubCategory', 'RetirementDate', 'RecommendationStatus'] with operators ['eq', 'and', 'or', 'lt', 'gt', 'le', 'ge']
.
The filter can also be applied to property ['trackingIds'], which uses the collection syntax trackingIds/any(t: t eq '<trackingId>').

Note: Control is a legacy filter property and will be deprecated in the future. Please use SubCategory for filtering recommendation subcategory.

Note: RecommendationStatus filter is available from API Version 2026-02-01-preview and onwards.

Note: Each trackingIds/any(...) predicate matches a single tracking ID; supplying multiple values inside one predicate is not supported. To match several tracking IDs, combine predicates with or. trackingIds can also be combined with the other supported filter properties using and.

Note: A tracking ID is an Azure Service Health tracking ID, for example 'VN1S-1V8'. It is not a GUID and is not the same value as RecommendationTypeGuid. A single tracking ID can map to more than one recommendation type, so a result set filtered by trackingIds is not guaranteed to contain a single RecommendationTypeGuid. trackingIds is a filter-only property and is not returned on the recommendation resource; use the recommendation metadata API to resolve a tracking ID to the recommendation types that carry it.

Valid options for SubCategory:
['BusinessContinuity', 'DisasterRecovery', 'HighAvailability', 'MonitoringAndAlerting', 'Other', 'Personalized', 'PrioritizedRecommendations', 'Scalability', 'ServiceUpgradeAndRetirement', 'Validation']

Example:
- $filter=Category eq 'Cost' and ResourceGroup eq 'MyResourceGroup'
-$filter=SubCategory eq 'ServiceUpgradeAndRetirement' and RetirementDate ge '2024-01-01' and RetirementDate le '2028-01-01'. Filter can be applied on trackingIds as well.
- $filter=trackingIds/any(t: t eq 'VN1S-1V8')
- $filter=ResourceId eq '/subscriptions/{subscriptionId}/resourceGroups/MyResourceGroup/providers/Microsoft.Storage/storageAccounts/mystorage' and trackingIds/any(t: t eq 'VN1S-1V8')
- $filter=trackingIds/any(t: t eq 'VN1S-1V8') or trackingIds/any(t: t eq '6TH2-BV8')

$skipToken
query

string

The page-continuation token to use with a paged version of this API.

$top
query

integer (int32)

The number of recommendations per page if a paged version of this API is being used.

Responses

Name Type Description
200 OK

ResourceRecommendationBaseListResult

Azure operation completed successfully.

Other Status Codes

ArmErrorResponse

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

ListRecommendationsSubscriptionResourceUri

Sample request

GET https://management.azure.com/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/providers/Microsoft.Advisor/recommendations?api-version=2026-10-01&$top=10

Sample response

{
  "nextLink": "https://management.azure.com/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/providers/Microsoft.Advisor/recommendations?api-version=2026-10-01&$top=10&$skiptoken=skiptoken",
  "value": [
    {
      "id": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/resourceGroups/resourceGroup/providers/Microsoft.Compute/availabilitysets/armavset/providers/Microsoft.Advisor/recommendations/2e7c72b2d7987ec224a1ebae03398b0fbdaa9a5a6a762e6fcf1c806599744b45",
      "name": "2e7c72b2d7987ec224a1ebae03398b0fbdaa9a5a6a762e6fcf1c806599744b45",
      "type": "Microsoft.Advisor/recommendations",
      "properties": {
        "category": "HighAvailability",
        "control": "HighAvailability",
        "impact": "Medium",
        "impactedField": "Microsoft.Compute/availabilitySets",
        "impactedValue": "armavset",
        "recommendationStatus": "New",
        "postponedUntilDateTime": "2020-10-25T22:24:43.3216408Z",
        "lastRefreshed": "2020-10-25T22:24:43.3216408Z",
        "lastUpdated": "2017-02-24T22:24:43.3216408Z",
        "risk": "Warning",
        "remediation": {
          "additionalProperties": {
            "httpMethod": "POST",
            "uri": "uri",
            "details": "link to document"
          }
        },
        "shortDescription": {
          "problem": "To ensure high availability add one or more virtual machines to this availability set",
          "solution": "To ensure high availability add one or more virtual machines to this availability set"
        },
        "resourceMetadata": {
          "resourceId": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/resourceGroups/resourceGroup/providers/Microsoft.Compute/availabilitysets/armavset",
          "action": {
            "additionalProperties": {
              "actionType": "Document",
              "link": "https://link3",
              "caption": "Enable Soft Delete to protect blob data",
              "description": "Enable Soft Delete to protect blob data"
            },
            "metadata": {
              "id": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc"
            }
          },
          "singular": "Availability set",
          "plural": "Availability sets"
        },
        "actions": [
          {
            "additionalProperties": {
              "actionType": "Document",
              "link": "https://link1",
              "caption": "Enable Soft Delete to protect blob data",
              "description": "Enable Soft Delete to protect blob data"
            },
            "metadata": {
              "id": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc"
            }
          }
        ],
        "description": "After enabling Soft Delete, deleted data transitions to a soft deleted state instead of being permanently deleted. When data is overwritten, a soft deleted snapshot is generated to save the state of the overwritten data. You can configure the amount of time soft deleted data is recoverable before it permanently expires.",
        "label": "Enable Soft Delete",
        "learnMoreLink": "https://link2",
        "potentialBenefits": "Save and recover your data when blobs or blob snapshots are accidentally overwritten or deleted"
      }
    },
    {
      "id": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/resourceGroups/resourceGroup/providers/Microsoft.Compute/virtualMachines/xyz/providers/Microsoft.Advisor/recommendations/2e7c72b2d7987ec224a1ebae03398b0fbdaa9a5a6a762e6fcf1c806599744b87",
      "name": "2e7c72b2d7987ec224a1ebae03398b0fbdaa9a5a6a762e6fcf1c806599744b87",
      "type": "Microsoft.Advisor/recommendations",
      "properties": {
        "category": "Security",
        "impact": "Medium",
        "impactedField": "Microsoft.Compute/virtualMachines",
        "impactedValue": "xyz",
        "recommendationStatus": "New",
        "postponedUntilDateTime": "2020-10-25T22:24:43.3216408Z",
        "lastRefreshed": "2020-10-25T22:24:43.3216408Z",
        "lastUpdated": "2017-02-24T22:24:43.3216408Z",
        "risk": "Warning",
        "shortDescription": {
          "problem": "Monitoring agent should be installed on your machines",
          "solution": "Monitoring agent should be installed on your machines"
        },
        "resourceMetadata": {
          "resourceId": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/resourceGroups/resourceGroup/providers/Microsoft.Compute/virtualMachines/xyz",
          "source": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/resourceGroups/resourceGroup/providers/Microsoft.Compute/virtualMachines/xyz/providers/Microsoft.Security/assessments/15e912ef-221a-4efe-80d2-df5671cdd5f5",
          "action": {
            "additionalProperties": {
              "actionType": "Document",
              "link": "https://link3",
              "caption": "Enable Soft Delete to protect blob data",
              "description": "Enable Soft Delete to protect blob data"
            },
            "metadata": {
              "id": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc"
            }
          },
          "singular": "Virtual machine",
          "plural": "Virtual machines"
        },
        "actions": [
          {
            "additionalProperties": {
              "actionType": "Document",
              "link": "https://link1",
              "caption": "Enable Soft Delete to protect blob data",
              "description": "Enable Soft Delete to protect blob data"
            },
            "metadata": {
              "id": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc"
            }
          }
        ],
        "description": "Monitoring agent should be installed on your machines.",
        "label": "Enable monitoring agent",
        "learnMoreLink": "https://link2",
        "potentialBenefits": "Protect and monitor machine",
        "trackedProperties": {
          "priority": "High"
        },
        "resourceWorkload": {
          "id": "0560dbdb-f207-4690-b4ba-1fc0c3a0f082",
          "name": "Critical VM Workload"
        },
        "review": {
          "id": "/subscriptions/a5481ee1-95df-47d0-85d4-dd3f0dfa19bc/providers/Microsoft.Advisor/assessments/MCWAR1",
          "name": "Monthly WAF Review 09/23"
        },
        "sourceSystem": "CxObserve",
        "notes": "This is a note"
      }
    }
  ]
}

Definitions

Name Description
ArmErrorResponse
ARMErrorResponseBody

ARM error response body.

Category

The category of the recommendation.

Control

The sub-category of the recommendation.

createdByType

The type of identity that created the resource.

Impact

The business impact of the recommendation.

Priority

The Priority of the Recommendation.

RecommendationDismissReason

The reason for dismissing the Recommendation.

RecommendationPropertiesResourceWorkload

The Workload that this Resource belongs to.

RecommendationPropertiesReview

The Review that this Recommendation belongs to.

RecommendationStatus

The state of the Recommendation applicable from v2026-02-01-preview.

ResourceMetadata

Recommendation resource metadata

ResourceRecommendationBase

Advisor Recommendation.

ResourceRecommendationBaseListResult

The response of a ResourceRecommendationBase list operation.

Risk

The potential risk of not implementing the recommendation.

ShortDescription

A summary of the recommendation.

systemData

Metadata pertaining to creation and last modification of the resource.

TrackedRecommendationProperties

The tracked properties of a Recommendation

ArmErrorResponse

Name Type Description
error

ARMErrorResponseBody

ARM error response body.

ARMErrorResponseBody

ARM error response body.

Name Type Description
code

string

Gets or sets the string that can be used to programmatically identify the error.

message

string

Gets or sets the string that describes the error in detail and provides debugging information.

Category

The category of the recommendation.

Value Description
HighAvailability
Security
Performance
Cost
OperationalExcellence

Control

The sub-category of the recommendation.

Value Description
HighAvailability
BusinessContinuity
DisasterRecovery
Scalability
MonitoringAndAlerting
ServiceUpgradeAndRetirement
Other
PrioritizedRecommendations
Personalized

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

Impact

The business impact of the recommendation.

Value Description
High
Medium
Low

Priority

The Priority of the Recommendation.

Value Description
Critical
High
Medium
Low
Informational

RecommendationDismissReason

The reason for dismissing the Recommendation.

Value Description
ExcessiveCostInvestmentRequired
TooComplexOrImpracticalToImplement
AnAlternativeSolutionIsAlreadyInPlace
IncompatibleWithTheCurrentConfiguration
ImplementationStepsAreUnclear
RiskIsAcceptable
Other

RecommendationPropertiesResourceWorkload

The Workload that this Resource belongs to.

Name Type Description
id

string

The Id of the Workload

name

string

The Name of the Workload

RecommendationPropertiesReview

The Review that this Recommendation belongs to.

Name Type Description
id

string

The ARM Resource Id of the Review

name

string

The Name of the Review

RecommendationStatus

The state of the Recommendation applicable from v2026-02-01-preview.

Value Description
New
Postponed
Dismissed
Completed

ResourceMetadata

Recommendation resource metadata

Name Type Description
action

management.azure.com.advisor.recommendations.list

The action to view resource.

plural

string

The plural user friendly name of resource type. eg: virtual machines

resourceId

string

Azure resource Id of the assessed resource

singular

string

The singular user friendly name of resource type. eg: virtual machine

source

string

Source from which recommendation is generated

ResourceRecommendationBase

Advisor Recommendation.

Name Type Description
id

string (arm-id)

Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"

name

string

The name of the resource

properties.actions

RecommendationProperties.Actions[]

The list of recommended actions to implement recommendation.

properties.category

Category

The category of the recommendation.

properties.completionType

string

The type of recommendation completion, which is either MarkedByUser or SystemVerified

properties.control

Control

The sub-category of the recommendation.

properties.createdTime

string (date-time)

The created time of the recommendation.

properties.description

string

The detailed description of recommendation.

properties.exposedMetadataProperties

management.azure.com.advisor.recommendations.list

The recommendation metadata properties exposed to customer to provide additional information.

properties.extendedProperties

object

Extended properties

properties.impact

Impact

The business impact of the recommendation.

properties.impactedField

string

The resource type identified by Advisor.

properties.impactedValue

string

The resource identified by Advisor.

properties.label

string

The label of recommendation.

properties.lastRefreshed

string (date-time)

The most recent time Advisor evaluated the recommendation for validity (re-ingested).

properties.lastUpdated

string (date-time)

The most recent time the recommendation state changed (manual or automated).

properties.learnMoreLink

string

The link to learn more about recommendation and generation logic.

properties.metadata

management.azure.com.advisor.recommendations.list

The recommendation metadata.

properties.notes

string

Additional notes for the Recommendation

properties.postponedUntilDateTime

string (date-time)

The time the Recommendation was postponed until.

properties.potentialBenefits

string

The potential benefit of implementing recommendation.

properties.recommendationDismissReason

RecommendationDismissReason

The reason the Recommendation was dismissed.

properties.recommendationStatus

RecommendationStatus

The state of the Recommendation

properties.recommendationTypeId

string

The recommendation-type GUID.

properties.remediation

management.azure.com.advisor.recommendations.list

The automated way to apply recommendation.

properties.resourceMetadata

ResourceMetadata

Metadata of resource that was assessed

properties.resourceWorkload

RecommendationPropertiesResourceWorkload

The Workload that this Resource belongs to.

properties.review

RecommendationPropertiesReview

The Review that this Recommendation belongs to.

properties.risk

Risk

The potential risk of not implementing the recommendation.

properties.shortDescription

ShortDescription

A summary of the recommendation.

properties.sourceSystem

string

The Source System that this Recommendation originated from.

properties.suppressionId

string

The single snoozed or dismissed rule for the recommendation.

properties.trackedProperties

TrackedRecommendationProperties

The properties of a tracked recommendation.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

ResourceRecommendationBaseListResult

The response of a ResourceRecommendationBase list operation.

Name Type Description
nextLink

string (uri)

The link to the next page of items

value

ResourceRecommendationBase[]

The ResourceRecommendationBase items on this page

Risk

The potential risk of not implementing the recommendation.

Value Description
Error
Warning
None

ShortDescription

A summary of the recommendation.

Name Type Description
problem

string

The issue or opportunity identified by the recommendation and proposed solution.

solution

string

The issue or opportunity identified by the recommendation and proposed solution.

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.

TrackedRecommendationProperties

The tracked properties of a Recommendation

Name Type Description
priority

Priority

The Priority of the Recommendation.